; drum crab canon

(require :asdf)
(asdf:load-system :smolmidi)    ; https://thrig.me/src/smolmidi.git
(in-package :cl-user)
(defpackage :drumc (:use :cl :smolmidi))
(in-package :drumc)
(block nil (setq *random-state* (make-random-state t)) (return))
(defun circular (items) (setf (cdr (last items)) items) items)

(defconstant +nmemb+ 5 "number of drums")
(defparameter *step* (circular '(24 7 12 5)))

(let ((pitch 24))
  (defun getpitch ()
    (prog1 pitch (incf pitch (pop *step*)))))

(defun velonoise () (+ (random 4) (random 4) (random 4)))
(defun velo (tnum accent i)
  (if (zerop tnum)
    (+ (velonoise) 78)
    (+ (velonoise) (if (zerop (mod i accent)) 96 64))))

(defun make-track (tnum meta maxdur)
  (let* ((track (new-track))
         (accent (+ 3 (random 5)))
         (pitch (getpitch))
         (dtime (car meta))
         (count (cadr meta))
         (dur   (* dtime count))
         (delay (- maxdur dur)))
    ;(patch-change track 0 47)
    (loop repeat (* count 2) for i from 0 do
          (if (and (plusp tnum) (= i count))
            (setf delay dtime)
            (progn
              (note-on  track delay pitch (velo tnum accent i))
              (note-off track dtime pitch 0)
              (setf delay 0))))
    track))

(defun genmeta ()
  (do ((i 1 (1+ i)) dcp (maxdur 0) (beats 24))
      ((> i +nmemb+) (values dcp maxdur))
    (let* ((dtime (+ 256 (* 16 (random 64))))
           (count beats)
           (dur (* dtime count)))
      (when (> dur maxdur) (setf maxdur dur))
      (decf beats (+ 4 (random 6)))
      (push (list dtime (if (plusp count) count 1))
            dcp))))

(defun make-tracks ()
  (multiple-value-bind (dcp maxdur) (genmeta)
    (format t "~&maxdur ~d from ~a~&" maxdur dcp)
    (loop repeat +nmemb+
          for n from 0 collect
          (make-track n (pop dcp) maxdur))))

(write-midi-file "drumc.midi" (make-tracks))